#pragma once
#include <cmath>
extern "C"
{
	__declspec(dllexport) struct Vec
	{
		float x, y, z;
	};
	__declspec(dllexport) struct Particle
	{
		float Drag;
		Vec Pos;
		Vec Vel;
		Vec Accel;
		float LifeTime;
		int active;
	};
}

float Length(Vec v);

Vec Normalize(Vec v);

Vec subtract(Vec v, Vec v2);

Vec add(Vec v, Vec v2);

Vec multiply(Vec v, float scalar);

class ParticleSystem
{
public:
	ParticleSystem();
	~ParticleSystem();
	void Update(Particle a_arr[], float dt);
	void spawn(Particle a_arr[]);
	void deSpawn(Particle &part);
	int m_MaxSize;
	Vec m_Pos;
	Vec m_Grav;
	float m_MaxDistance = 3;
	Particle *m_ParticleBuff;
	float SpawnRate;
	int MaxOutVelo;
	float lifeTime;
};