#include "Wrapper.h"
#include "ParticleSystem.h"
#include <windows.h>
#include <fstream>
#include <ctime>

ParticleSystem *g_PS;

void initSystem()
{
	g_PS = new ParticleSystem();
	srand((unsigned)time(0));
}

void initialize(Particle *p, int Size, int MaxDistance, int MaxOutVelo, float MaxLifeTime, float SpawnRate, float gravX, float gravY, float gravZ, float dt)
{
	g_PS->MaxOutVelo = MaxOutVelo;
	g_PS->lifeTime = MaxLifeTime;
	g_PS->SpawnRate = SpawnRate;
	g_PS->m_Grav.x = gravX;
	g_PS->m_Grav.y = gravY;
	g_PS->m_Grav.z = gravZ;

	g_PS->m_MaxDistance = MaxDistance;
	for (int i = 0; i < Size; i++)
	{
		float VeloVec[3];
		VeloVec[0] = (rand() % (2 * MaxOutVelo)) - MaxOutVelo;
		VeloVec[1] = (rand() % (2 * MaxOutVelo)) - MaxOutVelo;
		VeloVec[2] = (rand() % (2 * MaxOutVelo)) - MaxOutVelo;

		VeloVec[0] = VeloVec[0] / 100.f;
		VeloVec[1] = VeloVec[1] / 100.f;
		VeloVec[2] = VeloVec[2] / 100.f;

		p[i].Pos.x = g_PS->m_Pos.x;
		p[i].Pos.y = g_PS->m_Pos.y;
		p[i].Pos.z = g_PS->m_Pos.z;

		p[i].Vel.x = VeloVec[0];
		p[i].Vel.y = VeloVec[1];
		p[i].Vel.z = VeloVec[2];

		p[i].Accel.x = gravX;
		p[i].Accel.y = gravY;
		p[i].Accel.z = gravZ;

		p[i].LifeTime = MaxLifeTime;
	}
	g_PS->m_MaxSize = Size;
}

void updatePOS(float x, float y, float z)
{
	g_PS->m_Pos.x = x;
	g_PS->m_Pos.y = y;
	g_PS->m_Pos.z = z;
}

void updatePPOS(Particle *p, float dt)
{
	g_PS->Update(p, dt);
}

