﻿using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System;
using UnityEngine;

public class Emitter : MonoBehaviour {

    public GameObject particlePrefab;

    public int numOfParts;

    [DllImport("Particles")]
    public static extern void initSystem();

    [DllImport("Particles")]
    public static extern void initialize(Particles[] p, int Size, int MaxDistance, int MaxOutVelo, float MaxLifeTime, float SpawnRate, float gravX, float gravY, float gravZ, float dt);

	[DllImport("Particles")]
    public static extern void updatePOS(float x, float y, float z);

    [DllImport("Particles")]
    public static extern void updatePPOS(Particles[] p, float dt);

    [StructLayout(LayoutKind.Sequential)]
    public struct Vec
    {
        public float x, y, z;
    };
    [StructLayout(LayoutKind.Sequential)]
    public struct Particles
    {
        float Drag;
        public Vec Pos;
        public Vec Vel;
        public Vec Accel;
        public float LifeTime;
        public int active;
    };

    public GameObject[] g_Parts;
    public Particles[] parts;

    // Use this for initialization
    void Start()
    {
        g_Parts = new GameObject[100000];
        parts = new Particles[100000];
        initSystem();

        initialize(parts, parts.Length, 100, 40, 1.0f, 0.001f,
			0, 0.5f, 0
			,Time.deltaTime);
	}
    // Update is called once per frame
    void Update()
    {
        updatePOS(transform.position.x, transform.position.y, transform.position.z);       

        for (int i = 0; i < parts.Length; i++)
        {
            if (g_Parts[i] == null)
            {
                if (parts[i].active == 1)
                {
					
                    g_Parts[i] = Instantiate<GameObject>(particlePrefab);
                    g_Parts[i].transform.position = getPos(i);
				}
            }
            else
            {
                if (parts[i].active == 1)
                {
                    g_Parts[i].transform.position = getPos(i);
                }
                else
                {                    
                    g_Parts[i].gameObject.GetComponent<Particle>().die = true;
                }
            }
           
        }

        updatePPOS(parts, Time.deltaTime);

        if(Input.GetKey("w"))
        {
            transform.position += transform.up * Time.deltaTime*10; 
        }
        if (Input.GetKey("s"))
        {
            transform.position -= transform.up * Time.deltaTime*10;
        }
        if (Input.GetKey("a"))
        {
            transform.position -= transform.right * Time.deltaTime*10;
        }
        if (Input.GetKey("d"))
        {
            transform.position += transform.right * Time.deltaTime*10;
        }
        if (Input.GetKey("q"))
        {
            transform.position += transform.forward * Time.deltaTime*10;
        }
        if (Input.GetKey("e"))
        {
            transform.position -= transform.forward * Time.deltaTime*10;
        }		
    }
    public Vector3 getPos(int pos)
    {
        return new Vector3(parts[pos].Pos.x,parts[pos].Pos.y, parts[pos].Pos.z);
    }
}
